﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI

	' Variables added for the demo code
	Private fx As JFX
	Private sql1 As SQL
	Private sqlReservedWords As String = "|ABORT|ACTION|ADD|AFTER|ALL|ALTER|ANALYZE|AND|AS|ASC|ATTACH|AUTOINCREMENT|BEFORE|BEGIN|BETWEEN|BY|CASCADE|CASE|CAST|CHECK|COLLATE|COLUMN|COMMIT|CONFLICT|CONSTRAINT|CREATE|CROSS|CURRENT_DATE|CURRENT_TIME|CURRENT_TIMESTAMP|DATABASE|DEFAULT|DEFERRABLE|DEFERRED|DELETE|DESC|DETACH|DISTINCT|DROP|EACH|ELSE|END|ESCAPE|EXCEPT|EXCLUSIVE|EXISTS|EXPLAIN|FAIL|FOR|FOREIGN|FROM|FULL|GLOB|GROUP|HAVING|IF|IGNORE|IMMEDIATE|IN|INDEX|INDEXED|INITIALLY|INNER|INSERT|INSTEAD|INTERSECT|INTO|IS|ISNULL|JOIN|KEY|LEFT|LIKE|LIMIT|MATCH|NATURAL|NO|NOT|NOTNULL|NULL|OF|OFFSET|ON|OR|ORDER|OUTER|PLAN|PRAGMA|PRIMARY|QUERY|RAISE|RECURSIVE|REFERENCES|REGEXP|REINDEX|RELEASE|RENAME|REPLACE|RESTRICT|RIGHT|ROLLBACK|ROW|SAVEPOINT|SELECT|SET|TABLE|TEMP|TEMPORARY|THEN|TO|TRANSACTION|TRIGGER|UNION|UNIQUE|UPDATE|USING|VACUUM|VALUES|VIEW|VIRTUAL|WHEN|WHERE|WITH|WITHOUT|"
	Private XL As XLUtils
	Private workbook As XLWorkbookWriter
	Private XLReaderResult1 As XLReaderResult
	Private Const MAX_CHARS_IN_EXCEL_CELL As Int = 32767

End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
	XL.Initialize ' Initialise XLutils
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	sql1.InitializeSQLite("your sqlite dir", "your sqlite file", True) ' <<<< enter the correct values here
	workbook = XL.CreateWriterFromTemplate("your workbook dir", "your workbook file") ' <<<< enter the correct values here
	CopyOneWorksheetToTable("your worksheet name", False) ' <<<< enter the correct values here
	xui.MsgboxAsync("Done", "B4X")
End Sub

Private Sub CopyOneWorksheetToTable(worksheetName As String, copyHiddenRowsToo As Boolean) As ResumableSub

	Dim totalRows As Int
	Dim excelHdrs As List
	Dim excelHdrsLowerCase As List
	Dim excelColumnTypes As List
	Dim duplicateHdrs As String = ""
	Dim sqlColumns As List
	Dim sqlColumnTypes As List
	Dim tblName As String
	Dim actions As List = Array As String("Select table, append", "Select table, replace", "Create new table")
	Dim newTable As Boolean = True
	Dim i As Int
	Dim hdrExcelRowID As String = "ExcelRowID"
	Dim s As String
	Dim reportProgressEvery As Int = 100
	Dim rowsProcessed As Int = 0
	Dim sqlStatement As String = ""
	Dim sqlValuesPlaceholders As String = ""
	Dim iRow As Int
	Dim iCol As Int
	Dim allTables As List = GetAllTables(False)
	Dim isTextColumn As Boolean
	Dim allValuesNumeric As Boolean
	Dim lastCol0 As Int
	Dim headerRow0 As Int = 0 ' Assumption: the sheet's headers are in the first row
	Dim firstDataRow0 As Int = 1 ' Assumption: the sheet's data start in the second row
	Dim lastDataRow0 As Int

	' If the sheet contains merged regions, ask if they can be unmerged; if not, Return False
	' Code based on https://www.b4x.com/android/forum/threads/jpoi-clear-a-work-sheet.100852
	Dim theSheet As PoiSheet = workbook.PoiWorkbook.GetSheetByName(worksheetName)
	lastCol0 = theSheet.GetRow(0).Cells.Size - 1 ' Get the 0-based index of the last column of the first row
	Dim joTheSheet As JavaObject = theSheet
	Dim nregions As Int = joTheSheet.RunMethod("getNumMergedRegions", Array())
	If nregions > 0 Then
		If fx.Msgbox2(B4XPages.GetNativeParent(Me), "OK to unmerge cells? Worksheet: " & worksheetName, "XLtoSQLiteDemo", "Yes", "", "No", fx.MSGBOX_CONFIRMATION) <> fx.DialogResponse.POSITIVE Then
			UpdateStatusBar("", False)
			Sleep(0)
			Return False
		End If
		For i = (nregions - 1) To 0 Step -1
			joTheSheet.RunMethod("removeMergedRegion", Array(i))
		Next
	End If

	' Determine the output table
	tblName = MakeValidSQLiteName(worksheetName)
	If SQLiteTableExists(sql1, tblName) Then
		Wait For(SelectItemsFromList(B4XPages.GetNativeParent(Me), actions, "Table exists: " & tblName, False, 300, 150, False)) Complete (resultList As List)
		If resultList.Size <> 1 Then Return False
		Select Case resultList.Get(0)
			Case "Select table, append"
				newTable = False
				Wait For(SelectItemsFromList(B4XPages.GetNativeParent(Me), allTables, "Select table, append - " & tblName, False, 300, 300, False)) Complete (resultList As List)
				If resultList.Size <> 1 Then Return False
				tblName = resultList.Get(0).As(String)
			Case "Select table, replace"
				Wait For(SelectItemsFromList(B4XPages.GetNativeParent(Me), allTables, "Select table, replace - " & tblName, False, 300, 300, False)) Complete (resultList As List)
				If resultList.Size <> 1 Then Return False
				tblName = resultList.Get(0).As(String)
			Case Else ' "Create new table"
				tblName = SQLiteMakeNewTableName(sql1, tblName)
		End Select
	End If

	SetWaitCursor2(B4XPages.GetNativeParent(Me), True)
	Sleep(0)

	Try
		' Read the Worksheet
		AddText("Reading worksheet: " & worksheetName)
		Sleep(0)
		XLReaderResult1 = XL.Reader.SheetToResult(workbook.PoiWorkbook.GetSheetByName(worksheetName))
		lastDataRow0 = XLReaderResult1.BottomRight.Row0Based
		AddText("   Done")
		Sleep(0)
		' Get the column header data
		excelHdrs.Initialize
		excelHdrsLowerCase.Initialize
		sqlColumns.Initialize
		For i = 0 To lastCol0
			Dim hdr As String = XLReaderResult1.Get(XL.AddressZero(i, headerRow0))
			hdr = hdr.Trim
			If hdr = "" Then Continue
			If excelHdrsLowerCase.IndexOf(hdr.ToLowerCase) >= 0 Then
				If duplicateHdrs = "" Then
					duplicateHdrs = CRLF
				Else
					duplicateHdrs = duplicateHdrs & CRLF
				End If
				duplicateHdrs = duplicateHdrs & hdr
			Else
				excelHdrs.Add(hdr)
				excelHdrsLowerCase.Add(hdr.ToLowerCase)
				sqlColumns.Add(MakeValidSQLiteName(hdr))
			End If
		Next
		If excelHdrs.Size < 1 Then
			SetWaitCursor2(B4XPages.GetNativeParent(Me), False)
			Sleep(0)
			UpdateStatusBar("", False)
			Sleep(0)
			fx.Msgbox2(B4XPages.GetNativeParent(Me), "No headers were found in the first row of worksheet: " & worksheetName, "XLtoSQLiteDemo", "OK", "", "", fx.MSGBOX_ERROR)
			Return False
		Else If duplicateHdrs <> "" Then
			SetWaitCursor2(B4XPages.GetNativeParent(Me), False)
			Sleep(0)
			UpdateStatusBar("", False)
			Sleep(0)
			fx.Msgbox2(B4XPages.GetNativeParent(Me), "Duplicate headers were found in the first row of worksheet '" & worksheetName & "': " & duplicateHdrs, "XLtoSQLiteDemo", "OK", "", "", fx.MSGBOX_ERROR)
			Return False
		End If
		' Determine the header for the ExcelRowID column
		i = 0
		Do While excelHdrsLowerCase.IndexOf(hdrExcelRowID.ToLowerCase) & IIf(i = 0, "", "_" & i) >= 0
			i = i + 1
		Loop
		hdrExcelRowID = hdrExcelRowID & IIf(i = 0, "", "_" & i)
	Catch
		s = LastException
		Log("Import failed - " & worksheetName & ": " & s)
		SetWaitCursor2(B4XPages.GetNativeParent(Me), False)
		Sleep(0)
		UpdateStatusBar("", False)
		Sleep(0)
		fx.Msgbox2(B4XPages.GetNativeParent(Me), s, "Import failed - " & worksheetName, "OK", "", "", fx.MSGBOX_ERROR)
		Return False
	End Try

	' Inits
	totalRows = XLReaderResult1.BottomRight.Row0Based + 1

	' Try to determine column types other than 'TEXT'
	' See https://poi.apache.org/apidocs/dev/org/apache/poi/ss/usermodel/BuiltinFormats.html
	sqlColumnTypes.Initialize
	excelColumnTypes.Initialize
	' Check the format of the cell in the first data row
	For iCol = 0 To lastCol0
		Dim row As PoiRow = workbook.PoiWorkbook.GetSheetByName(worksheetName).GetRow(XL.AddressZero(iCol, firstDataRow0).Row0Based)
		Dim Cell As PoiCell = row.GetCell(XL.AddressZero(iCol, firstDataRow0).Col0Based)
		Dim props As Map
		props.Initialize
		FillStyleFromCell(props, Cell.CellStyle) ' Get the cell's style properties, which include the data format
		'Log("iCol=" & iCol & " (" & excelHdrs.Get(iCol - 0) & "); dataformat=" & props.GetDefault("setDataFormat", "?"))
		Select Case props.GetDefault("setDataFormat", 0).As(Int)
			Case 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 37, 38, 39, 40, 41, 42, 43, 44
				' Numbers with or without decimals
				sqlColumnTypes.Add("NUMERIC")
				excelColumnTypes.Add("NUMERIC")
			Case 11, 48
				' Float
				sqlColumnTypes.Add("NUMERIC")
				excelColumnTypes.Add("NUMERIC")
			Case 14, 15, 16, 17, 169 ' 169: not documented on the aforementioned page, found it experimentally with the above 'Log' statement
				' Date
				sqlColumnTypes.Add("TEXT")
				excelColumnTypes.Add("DATE")
			Case 18, 19, 20, 21, 45, 46, 47
				' Time
				sqlColumnTypes.Add("TEXT")
				excelColumnTypes.Add("TIME")
			Case 22
				' Datetime
				sqlColumnTypes.Add("TEXT")
				excelColumnTypes.Add("DATETIME")
			Case Else
				' Text
				sqlColumnTypes.Add("TEXT")
				excelColumnTypes.Add("TEXT")
		End Select
	Next
	' Check all values to ensure e.g. a 'guessed' numeric column won't contain any non-numeric values
	For iCol = 0 To lastCol0
		UpdateStatusBar("Checking data formats: " & excelHdrs.Get(iCol - 0) & "...", True)
		Sleep(0)
		allValuesNumeric = True
		isTextColumn = (sqlColumnTypes.Get(iCol - 0) = "TEXT")
		For iRow = firstDataRow0 To lastDataRow0
			If XLReaderResult1.Get(XL.AddressZero(iCol, iRow)).As(String) = "" Then Continue
			If isTextColumn Then ' If the column contains nothing but numeric values, force data type numeric
				If allValuesNumeric Then ' So far, no non-numeric values were found
					Try
						Dim dbl As Double = XLReaderResult1.Get(XL.AddressZero(iCol, iRow)).As(Double)
					Catch
						allValuesNumeric = False
						Exit
					End Try
				End If
			Else
				Try
					Dim dbl As Double = XLReaderResult1.Get(XL.AddressZero(iCol, iRow)).As(Double)
				Catch
					' Non-numeric value found in the column, change its type to TEXT and stop checking this column
					sqlColumnTypes.Set(iCol - 0, "TEXT")
					excelColumnTypes.Set(iCol - 0, "TEXT")
					dbl = dbl ' Just avoiding a compiler warning here
					Exit
				End Try
			End If
		Next
		If isTextColumn And allValuesNumeric Then
			sqlColumnTypes.Set(iCol - 0, "NUMERIC")
		End If
	Next

	Try
		iRow = -1
		' Create the output table?
		If newTable Then
			sql1.ExecNonQuery("DROP TABLE IF EXISTS [" & tblName & "]")
			s = "CREATE TABLE [" & tblName & "]("
			For i = 0 To (sqlColumns.Size - 1)
				If i > 0 Then s = s & ", "
				If sqlColumnTypes.Get(i).As(String) = "TEXT" Then
					s = s & "[" & sqlColumns.Get(i).As(String) & "] VARCHAR(" & MAX_CHARS_IN_EXCEL_CELL & ")"
				Else
					s = s & "[" & sqlColumns.Get(i).As(String) & "] " & sqlColumnTypes.Get(i).As(String)
				End If
			Next
			s = s & ", [" & hdrExcelRowID & "] INT)"
			sql1.ExecNonQuery(s)
		End If
		' Prepare the SQLite statement
		sqlStatement = "INSERT OR REPLACE INTO [" & tblName & "] ("
		sqlValuesPlaceholders = ""
		For Each oneSqlColumn As String In sqlColumns
			If sqlValuesPlaceholders <> "" Then
				sqlStatement = sqlStatement & ", "
				sqlValuesPlaceholders = sqlValuesPlaceholders & ", "
			End If
			sqlStatement = sqlStatement & "[" & oneSqlColumn & "]"
			sqlValuesPlaceholders = sqlValuesPlaceholders & "?"
		Next
		sqlStatement = sqlStatement & ", [" & hdrExcelRowID & "]) VALUES (" & sqlValuesPlaceholders & ", ?)"
		' Process the data
		For iRow = firstDataRow0 To lastDataRow0
			' Report progress
			rowsProcessed = rowsProcessed + 1
			If rowsProcessed Mod reportProgressEvery = 0 Then
				UpdateStatusBar("Processing " & rowsProcessed & "/" & totalRows & "...", True)
				Sleep(0)
			End If
			' Copy visible rows only?
			If copyHiddenRowsToo = False Then
				If XLrowIsHidden(workbook.PoiWorkbook.GetSheetByName(worksheetName).GetRow(XL.AddressZero(0, iRow).Row0Based)) Then Continue
			End If
			' Build the list with the values from the Excel Worksheet
			Dim sqlValuesList As List
			sqlValuesList.Initialize
			For iCol = 0 To lastCol0
				s = XLReaderResult1.Get(XL.AddressZero(iCol, iRow)).As(String)
				Select Case excelColumnTypes.Get(iCol - 0).As(String)
					Case "DATE"
						If s = "" Then
							sqlValuesList.Add("NULL")
						Else
							sqlValuesList.Add(DateToYYYYMMDDwithHyphens(s.As(Long)))
						End If
					Case "TIME"
						If s = "" Then
							sqlValuesList.Add("NULL")
						Else
							sqlValuesList.Add(DateToTimeOnly(s.As(Long)))
						End If
					Case "DATETIME"
						If s = "" Then
							sqlValuesList.Add("NULL")
						Else
							sqlValuesList.Add(DateToTimeStampForFilenameWithMsecs(s.As(Long), ":").Replace(".", ":"))
						End If
					Case Else
						sqlValuesList.Add(s)
				End Select
			Next
			sqlValuesList.Add(iRow + 1)
			' Write the SQLite row
			sql1.ExecNonQuery2(sqlStatement, sqlValuesList)
		Next
		iRow = -1
	Catch
		s = LastException
		Log(sqlStatement)
		Log("Import failed - " & worksheetName & IIf(iRow < 0, ": ", " (R" & iRow & "): ") & s)
		SetWaitCursor2(B4XPages.GetNativeParent(Me), False)
		Sleep(0)
		UpdateStatusBar("", False)
		Sleep(0)
		fx.Msgbox2(B4XPages.GetNativeParent(Me), s, "Import failed: " & worksheetName & IIf(iRow < 0, ": ", " (R" & iRow & "): "), "OK", "", "", fx.MSGBOX_ERROR)
		Return False
	End Try

	UpdateStatusBar("", False)
	Sleep(0)

	Return True

End Sub

Private Sub GetAllTables(includeMeta As Boolean) As List ' IncludeMeta is not relevant for you, code comes from one of my projects; it excludes a table called 'Meta' if it exists

	Dim allTables As List

	If includeMeta = False Then
		allTables = SQLiteGetTables(sql1)
		Dim i As Int = allTables.IndexOf("Meta")
		If i >= 0 Then allTables.RemoveAt(i)
	End If

	allTables.Sort(True)

	Return allTables

End Sub

Private Sub UpdateStatusBar(txt As String, ignore As Boolean) ' This comes from other code, simplified it here by just logging the text

	Log(txt)

End Sub

Private Sub AddText(txt As String) ' This comes from other code, simplified it here by just logging the text

	Log(txt)

End Sub

#Region Utility ' Code comes from my utilities class
Public Sub MakeValidSQLiteName(strIn As String) As String

	Dim strOut As String = ""
	Dim i As Int
	Dim s As String

	For i = 0 To (strIn.Length - 1)
		s = strIn.SubString2(i, i + 1)
		If s = "_" Then
			strOut = strOut & s
		Else If IsNumber(s) Then
			If i = 0 Then strOut = strOut & "_"
			strOut = strOut & s
		Else If (s.ToUpperCase.CompareTo("A") >= 0) And (s.ToUpperCase.CompareTo("Z") <= 0) Then
			strOut = strOut & s
		Else
			strOut = strOut & "_"
		End If
	Next

	If sqlReservedWords.Contains("|" & strOut.ToLowerCase & "|") Then strOut = "_" & strOut

	Do While strOut.Contains("__")
		strOut = strOut.Replace("__", "_")
	Loop

	Return strOut

End Sub

Public Sub SetWaitCursor2(frm As Form, waitCursor As Boolean)

	Try
		If waitCursor Then
			frm.RootPane.MouseCursor = fx.Cursors.WAIT
		Else
			frm.RootPane.MouseCursor = fx.Cursors.DEFAULT
		End If
	Catch
		Log("SetWaitCursor2: " & LastException)
	End Try

End Sub

Public Sub SQLiteGetTables(sqlDb As SQL) As List

	' Code based on https://www.b4x.com/android/forum/threads/b4x-sqlite-get-all-tables-column-names-and-definitions-of-a-db.85886/

	Dim TBName As String
	Dim RSDB As ResultSet=sqlDb.ExecQuery("Select name FROM sqlite_master WHERE Type='table' ORDER BY name")
	Dim ReturnList As List
	ReturnList.Initialize
	Do While RSDB.NextRow
		TBName=RSDB.GetString2(0)
		If TBName.StartsWith("SQlite") = False Then ReturnList.Add(TBName)
	Loop
	ReturnList.Sort(True)
	RSDB.Close
	Return ReturnList

End Sub

Public Sub SQLiteTableExists(sqlDb As SQL, tableName As String) As Boolean

	' Code based on DBUTILS 2 : https://www.b4x.com/android/forum/threads/b4x-dbutils-2.81280/

	Dim count As Int = sqlDb.ExecQuerySingleResult2("SELECT count(name) FROM sqlite_master WHERE type='table' AND name=? COLLATE NOCASE", Array As String(MakeValidSQLiteName(tableName)))
	Return count > 0

End Sub

Public Sub SQLiteMakeNewTableName(sqlDb As SQL, tableName As String) As String

	Dim i As Int
	Dim back As String
	Dim front As String

	tableName = MakeValidSQLiteName(tableName)

	Do While SQLiteTableExists(sqlDb, tableName)
		If tableName.EndsWith("_") Then
			tableName = tableName & "1"
		Else
			i = tableName.LastIndexOf("_")
			If i >= 0 Then
				front = tableName.SubString2(0, i)
				back = tableName.SubString(i + 1)
				If IsUnsignedInteger(back, False) Then
					i = back
					i = i + 1
					tableName = front & "_" & i
				Else
					tableName = tableName & "_1"
				End If
			Else
				tableName = tableName & "_1"
			End If
		End If
	Loop

	Return tableName

End Sub

Public Sub IsUnsignedInteger(s As String, allowNullString As Boolean) As Boolean

	' Regex expression based on http://regexlib.com/Search.aspx?k=integer&AspxAutoDetectCookieSupport=1
	If allowNullString And (s = "") Then
		Return True
	Else
		Return IsNumber(s) And Regex.IsMatch("^\d+$", s)
	End If

End Sub

Public Sub SelectItemsFromList(frm As Form, lst As List, title As String, allowMultiple As Boolean, dlgWidth As Int, dlgHeight As Int, showOkButton As Boolean) As ResumableSub

	Dim fnt14 As B4XFont = xui.CreateDefaultFont(14)
	Dim ListTemplate As B4XListTemplate
	Dim dlg As B4XDialog

	dlg.Initialize(frm.RootPane)
	dlg.BackgroundColor = xui.Color_White
	dlg.BlurBackground = True
	dlg.BorderColor = xui.Color_Black
	dlg.ButtonsColor = xui.Color_LightGray
	dlg.ButtonsFont = fnt14
	dlg.ButtonsTextColor = xui.Color_Black
	dlg.Title = title
	dlg.TitleBarColor = xui.Color_LightGray
	dlg.TitleBarFont = fnt14
	dlg.TitleBarTextColor = xui.Color_Black

	ListTemplate.Initialize
	ListTemplate.Resize(dlgWidth, dlgHeight)
	ListTemplate.AllowMultiSelection = allowMultiple
	ListTemplate.SelectionColor = xui.Color_LightGray
	ListTemplate.CustomListView1.DesignerLabel.Style = "" ' This, together with the Font setting, avoids having all text items in bold
	ListTemplate.CustomListView1.DesignerLabel.Font = fnt14
	ListTemplate.CustomListView1.DesignerLabel.Alignment = "CENTER_LEFT"
	ListTemplate.CustomListView1.DefaultTextColor = xui.Color_Black
	ListTemplate.CustomListView1.DefaultTextBackgroundColor = xui.Color_White
	ListTemplate.Options = lst

	Wait For (dlg.ShowTemplate(ListTemplate, IIf(showOkButton Or allowMultiple, "OK", ""), "", "Cancel")) Complete (Result As Int)
	If Result <> xui.DialogResponse_Positive Then
		Dim l As List
		l.Initialize
		Return l
	Else
		Return ListTemplate.SelectedItems
	End If

End Sub

'Call as:
'Dim props as Map
'Dim Cell As PoiCell
'FillStyleFromCell(props, Cell.CellStyle)
Private Sub FillStyleFromCell(props As Map, CellStyle As PoiCellStyle)

	' Code from XLUtils.b4xlib/XLSheetWriter.bas - see https://www.b4x.com/android/forum/threads/xlutils-jpoi-5-read-styles.140554

	Dim jStyle As JavaObject = CellStyle
	For Each methods As List In workbook.InternalAllSimpleMethods
		For Each method As String In methods
			props.Put(method, jStyle.RunMethod("g" & method.SubString(1), Null))
		Next
	Next
	props.Put("setFont", jStyle.RunMethod("getFontIndex", Null))
	For Each method As String In workbook.InternalStyleStrings
		props.Put(method, jStyle.RunMethodJO("g" & method.SubString(1), Null).RunMethod("toString", Null))
	Next

End Sub

Public Sub XLrowIsHidden(poiRow1 As PoiRow) As Boolean

	Return Not(XLrowIsVisible(poiRow1))

End Sub

Public Sub XLrowIsVisible(poiRow1 As PoiRow) As Boolean

	If poiRow1.Height = 0 Then
		Return False
	Else
		Dim joRow As JavaObject = poiRow1
		Dim zeroHeight As Boolean = joRow.RunMethod("getZeroHeight", Null)
		Return Not(zeroHeight)
	End If

End Sub

Public Sub DateToYYYYMMDDwithHyphens(dateIn As Long) As String

	Dim OrigFormat As String = DateTime.DateFormat 'save orig date format
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim YYYYMMDDout As String = DateTime.Date(dateIn)
	DateTime.DateFormat = OrigFormat 'return to orig date format
	Return YYYYMMDDout

End Sub

Public Sub DateToTimeOnly(dateIn As Long) As String

	Dim OrigFormat As String = DateTime.DateFormat 'save orig date format
	DateTime.DateFormat = "HH:mm:ss"
	Dim strOut As String = DateTime.Date(dateIn)
	DateTime.DateFormat = OrigFormat 'return to orig date format
	Return strOut

End Sub

Public Sub DateToTimeStampForFilenameWithMsecs(dateIn As Long, msecSep As String) As String

	If msecSep = "" Then msecSep = ","

	Dim OrigFormat As String = DateTime.DateFormat 'save orig date format
	DateTime.DateFormat = "yyyy-MM-dd HH.mm.ss" & msecSep & "SSS"
	Dim strOut As String = DateTime.Date(dateIn)
	DateTime.DateFormat = OrigFormat 'return to orig date format
	Return strOut

End Sub
#End Region ' Utility